unit dlg400;

(*
Copyright (C) 1998 Paul Toth (TothPaul@Mygale.org)
 http://www.mygale.org/~tothpaul

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*)



interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, as400;

type
  TDlgForm = class(TForm)
    AS400: TAS400;
    SysList: TSysList;
    LibList: TLibList;
    LibFiles: TLibFiles;
    LibFileSelection1: TLibFileSelection;
    OK: TButton;
    Cancel: TButton;
    TableName: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    LibName: TLabel;
    Info: TLabel;
    procedure TableNameKeyPress(Sender: TObject; var Key: Char);
    procedure SysListChange(Sender: TObject);
    procedure OKClick(Sender: TObject);
    procedure LibFilesClick(Sender: TObject);
    procedure LibListClick(Sender: TObject);
  private
    { Dclarations prives }
    procedure FindLib;
  public
    { Dclarations publiques }
  end;

// TDlg400 (used TDlgForm in Dlg400.pas)
  TSelection=(slAll,slData,slLogical,slPhysical,slSource);
  TDlg400 = class(TCustom400)
  Private
   fSysName:string;
   fLibName:string;
   fTableName:string;
   fSelection:TSelection;
   fDlgForm:TDlgForm;
  Public
   Function Execute:boolean;
   Function Fullname:string;
  Published
   Property SysName:string read fSysName write fSysName;
   Property LibName:string read fLibName write fLibName;
   Property TableName:string read fTableName write fTableName;
   property Selection:TSelection read fSelection write fSelection;
  end;

var
  DlgForm: TDlgForm;

implementation

{$R *.DFM}

procedure TDlgForm.TableNameKeyPress(Sender: TObject; var Key: Char);
begin
 if Key=#13 then FindLib;
end;

procedure TDlgForm.FindLib;
 Var
  s,ss:string;
  p:byte;
  i:integer;
  Procedure GoLib(NewLib:string);
   begin
    i:=LibList.Items.IndexOf(NewLib);
    if i<0 then begin { not in the LibList }
//     Try
      LibFiles.LibName:=NewLib;
      LibList.ItemIndex:=LibList.Items.Add(NewLib);
//      Transfer1.FileList(NewLib,FileList.Items,cLogical.Checked); { try to get FileList }
//      fLibName:=NewLib; LibList.ItemIndex:=LibList.Items.Add(fLibName); { add Lib }
//     Except
//      On E:ECawin do begin ShowMessage(E.Message); s:=''; end;{ not a valid libname }
//     end;
    end else begin   { existing lib }
//     fLibName:=NewLib;
     LibList.ItemIndex:=i; { set it active }
//     Transfer1.FileList(fLibName,FileList.Items,cLogical.Checked); { build file list }
    end;
    LibName.Caption:='\\'+AS400.Sysname+'\'+LibFiles.LibName;
   end;
 begin
  s:=UpperCase(TableName.Text);
 // sysname
  p:=Pos('//',s); if p=0 then p:=pos('\\',s);
  if p=1 then begin { '//'}
   s:=copy(s,3,length(s)); // remove '//'
   p:=pos('/',s); if p=0 then p:=pos('\',s);
   ss:=Copy(s,1,p-1);  { extract sys name }
   s:=Copy(s,p+1,Length(s));
   sysList.SysName:=ss; // exception on unknow system
  end;
 //
  p:=Pos('/',s); if p=0 then p:=Pos('\',s);
  if p>0 then begin { '/'  }
   ss:=Copy(s,1,p-1);  { extract lib name }
   if LibFiles.LibName<>ss then GoLib(ss); { not the current one }
   if s<>'' then begin; {  a valid lib }
    ss:=Copy(s,p+1,Length(s)); { extract file name }
    i:=LibFiles.Items.IndexOf(ss);
    if i>=0 then {fFileName:='' else begin fFileName:=ss; FileList.ItemIndex:=i; end;}
                  LibFiles.ItemIndex:=i;
   end;
  end else
  { no '/' } if s<>'' then GoLib(s);
  TableName.Text:=s;
 end;

procedure TDlgForm.SysListChange(Sender: TObject);
begin
 Info.Caption:=AS400.UserName;
 LibName.Caption:='\\'+SysList.sysname+'\'+LibFiles.LibName;
end;

procedure TDlgForm.OKClick(Sender: TObject);
begin
 TableName.Text:=LibFiles.Items[LibFiles.ItemIndex];
 ModalResult:=mrOk;
end;

procedure TDlgForm.LibFilesClick(Sender: TObject);
begin
 TableName.Text:=LibFiles.Items[LibFiles.ItemIndex];
end;

procedure TDlgForm.LibListClick(Sender: TObject);
begin
 LibName.Caption:='\\'+SysList.sysname+'\'+LibFiles.LibName;
end;

// TDlg400
Function TDlg400.Fullname:string;
//'\\'+fSysName+'\'+fLibName+'\'+fTableName;
 begin
  if (fSysName<>'')and(fLibName<>'') then
   Result:='\\'+fSysName+'\'+fLibName+'\'+fTableName
  else
   Result:=fTableName;
 end;

Function TDlg400.Execute:boolean;
 begin
  Result:=False;
  if fDlgForm=nil then fDlgForm:=TDlgForm.Create(Application);
  With fDlgForm do begin
   TableName.Text:=FullName;
   ShowModal;
   if ModalResult=mrOk then begin
    fSysName:=SysList.SysName;
    fLibName:=LibFiles.LibName;
    fTableName:=TableName.Text;
    Result:=True;
   end;
  end;
 end;



end.
