unit parmedit;

(*
Copyright (C) 1998 Paul Toth (TothPaul@Mygale.org)
 http://www.mygale.org/~tothpaul

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*)



interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, AS400,
  ExtCtrls, StdCtrls, Menus, DsgnIntf;

type
  TParmEditor = class(TForm)
    ParmList: TListBox;
    PopupMenu1: TPopupMenu;
    Add1: TMenuItem;
    Delete1: TMenuItem;
    Clearall1: TMenuItem;
    procedure ParmListClick(Sender: TObject);
    procedure Add1Click(Sender: TObject);
    procedure Delete1Click(Sender: TObject);
    procedure Clearall1Click(Sender: TObject);
  private
    fCall400:TCall400;
    procedure SetCall400(Value:TCall400);
    procedure BuildList;
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
  public
    Designer400:TFormDesigner;
    Property Call400:TCall400 read fCall400 write SetCall400;
  end;

var
  ParmEditor: TParmEditor;

implementation

{$R *.DFM}

procedure TParmEditor.SetCall400(Value:TCall400);
 begin
  fCall400:=Value;
  Caption:=Call400.Owner.Name+'.'+Call400.Name+':'+Call400.ClassName;
  BuildList;
 end;

procedure TParmEditor.BuildList;
 var
  i:integer;
 begin
  ParmList.clear;
  for i:=0 to Call400.ParmCount-1 do begin
   ParmList.Items.add(Call400.Parms[i].Name);
  end;
 end;

procedure TParmEditor.Notification(AComponent: TComponent; Operation: TOperation);
 begin
  inherited Notification(AComponent,Operation);
  if (AComponent=Call400)and(Operation=opRemove) then Hide;
 end;

procedure TParmEditor.ParmListClick(Sender: TObject);
begin
 Designer400.SelectComponent(Call400.ParmByName(ParmList.Items[ParmList.ItemIndex]));
end;

procedure TParmEditor.Add1Click(Sender: TObject);
var
 AName:string;
 index:integer;
begin
 index:=0;
 repeat
  inc(index);
  AName:=Call400.Name+'Parm'+IntToStr(Index);
 until Call400.ParmByName(AName)=nil;
 Call400.AddParm(AName,tChar,1,0);
 BuildList;
end;

procedure TParmEditor.Delete1Click(Sender: TObject);
begin
 if ParmList.ItemIndex<0 then exit;
 Call400.ParmByName(ParmList.Items[ParmList.ItemIndex]).Free;
 BuildList;
end;

procedure TParmEditor.Clearall1Click(Sender: TObject);
begin
 while Call400.ParmCount>0 do Call400.Parms[0].Free;
 BuildList;
end;

end.
